/* ***** BEGIN LICENSE BLOCK *****
 *    Copyright 2002 Michel Jacobson jacobson@idf.ext.jussieu.fr
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * ***** END LICENSE BLOCK ***** */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* **
 * CGI for cutting a peace of data inside a media file (for now only mp3 and PCM/wav) and send it
 * to the client.
 * TODO: doing the same thing with .aif and .avi files
 * USAGE: http://localhost/cgi-bin/audiocut?file=a.wav&start=0.0000&end=4.5400
 * param file:  location of the media file from mypath variable
 *       start: start time expressed in sec.millisec
 *       end:   end time expressed in sec.millisec
 *
 * Put the mypath variable to the directory where you store your media files
 * **/
const char     *mypath = "c:/lacito.archivage.vjf.cnrs.fr/archives/";
char           edited[4096];
char           file[4096];
float          from = 0.0;
float          to   = 0.0;
FILE           *fp, *fopen();

char x2c(char hi, char lo) {
	register char   digit;
	register int    hibyte, lobyte, index;
	char            hextable[] = "0123456789ABCDEF";
				 index = 0;
	while (hi != hextable[index]) {
		index++;
	}
	hibyte = index;
	hibyte *= 16;
	index = 0;
	while (lo != hextable[index]) {
		index++;
	}
	lobyte = index;
	hibyte = hibyte + lobyte;
	digit = (char) hibyte;
	return (digit);
}
char * get_value(char unedited[]) {
	int             u_ptr, e_ptr;
				 e_ptr = 0;
	for (u_ptr = 0; u_ptr <= (int) strlen(unedited); u_ptr++) {
		if (unedited[u_ptr] == (char) '\045') {
			edited[e_ptr] = x2c(
					    unedited[u_ptr + 1],
					    unedited[u_ptr + 2]);
			u_ptr += 2;
		} else {
			edited[e_ptr] = unedited[u_ptr];
		}
		e_ptr++;
	}
	return edited;
}
void param(char *token) {
	char           *name_ptr;
	char 		   *value_ptr;
	char           n[4096];
	char           v[4096];
		name_ptr = token;
		value_ptr = strchr(token, '=');

		*value_ptr = '\000';
		value_ptr++;

		strcpy(n, get_value(name_ptr));
		strcpy(v, get_value(value_ptr));
		if (strcmp(n, "file") == 0) {
			strcpy(file, mypath);
			strcat(file, v);
		} else if (strcmp(n, "start") == 0) {
			sscanf(v, "%f", &from);
		} else if (strcmp(n, "end") == 0) {
			sscanf(v, "%f", &to);
		}
}
char test(char x, int n) {
	int a = ((x) & (1 << n));
	if (a > 0) {
		return '1';
	} else {
		return '0';
	}
}
long readHeader(char a, char b, char c, char d, long *sr, int *fs, int *vers, int *lay, int *br) {
	long        frameLengthInBytes = 0;
	long        sampleRate = 0;
	int         frameSize = 0;
	int         version = 0; // 0=>reserved; 1=>version 1; 2=>version 2; 3=>version 2.5
	int         layer = 0;   // 0=>reserved; 1=>layer I; 2=>layer II; 3=>layer III
	int         bitRate = 0;
	int         padding = 0;

	char        tableau[32];
	int         cpt = 0;
	int         i;

	for (i=7;i>=0;i--) {
		tableau[cpt++] = test(a, i);
	}
	for (i=7;i>=0;i--) {
		tableau[cpt++] = test(b, i);
	}
	for (i=7;i>=0;i--) {
		tableau[cpt++] = test(c, i);
	}
	for (i=7;i>=0;i--) {
		tableau[cpt++] = test(d, i);
	}

	//version
	if (tableau[11] == '0') {
		if (tableau[12] == '0') {
			version = 3;
		}
	} else {
			if (tableau[12] == '0') {
				version = 2;
			} else {
				version = 1;
			}
	}

	//layer
	if (tableau[13] == '0') {
		if (tableau[14] == '1') {
			layer = 3;
		}
	} else {
			if (tableau[14] == '0') {
				layer = 2;
			} else {
				layer = 1;
			}
	}

	//bitRate
	if (tableau[16] == '0') {				//0
		if (tableau[17] == '0') {			//00
			if (tableau[18] == '0') {		//000
				if (tableau[19] == '0') {	//0000
					bitRate = 0;			//free
				} else {					//0001
					if ((version == 1) && (layer == 1)) {
						bitRate = 32;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 32;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 32;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 32;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 8;
					}
				}
			} else {						//001
				if (tableau[19] == '0') {	//0010
					if ((version == 1) && (layer == 1)) {
						bitRate = 64;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 48;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 40;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 48;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 16;
					}
				} else {					//0011
					if ((version == 1) && (layer == 1)) {
						bitRate = 96;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 56;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 48;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 56;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 24;
					}
				}
			}
		} else {							//01
			if (tableau[18] == '0') {		//010
				if (tableau[19] == '0') {	//0100
					if ((version == 1) && (layer == 1)) {
						bitRate = 128;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 64;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 56;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 64;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 32;
					}
				} else {					//0101
					if ((version == 1) && (layer == 1)) {
						bitRate = 160;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 80;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 64;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 80;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 40;
					}
				}
			} else {						//011
				if (tableau[19] == '0') {	//0110
					if ((version == 1) && (layer == 1)) {
						bitRate = 192;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 96;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 80;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 96;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 48;
					}
				} else {					//0111
					if ((version == 1) && (layer == 1)) {
						bitRate = 224;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 112;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 96;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 112;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 856;
					}
				}
			}
		}
	} else {								//1
		if (tableau[17] == '0') {			//10
			if (tableau[18] == '0') {		//100
				if (tableau[19] == '0') {	//1000
					if ((version == 1) && (layer == 1)) {
						bitRate = 256;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 128;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 112;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 128;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 64;
					}
				} else {					//1001
					if ((version == 1) && (layer == 1)) {
						bitRate = 288;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 160;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 128;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 144;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 80;
					}
				}
			} else {						//101
				if (tableau[19] == '0') {	//1010
					if ((version == 1) && (layer == 1)) {
						bitRate = 320;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 192;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 160;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 160;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 96;
					}
				} else {					//1011
					if ((version == 1) && (layer == 1)) {
						bitRate = 352;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 224;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 192;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 176;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 112;
					}
				}
			}
		} else {							//11
			if (tableau[18] == '0') {		//110
				if (tableau[19] == '0') {	//1100
					if ((version == 1) && (layer == 1)) {
						bitRate = 384;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 256;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 224;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 192;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 128;
					}
				} else {					//1101
					if ((version == 1) && (layer == 1)) {
						bitRate = 416;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 320;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 256;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 224;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 144;
					}
				}
			} else {						//111
				if (tableau[19] == '0') {	//1110
					if ((version == 1) && (layer == 1)) {
						bitRate = 448;
					} else if ((version == 1) && (layer == 2)) {
						bitRate = 384;
					} else if ((version == 1) && (layer == 3)) {
						bitRate = 320;
					} else if (((version == 2) || (version == 3)) && (layer == 1)) {
						bitRate = 256;
					} else if (((version == 2) || (version == 3)) && ((layer == 2) || (layer == 3))) {
						bitRate = 160;
					}
				} else {					//1111
					bitRate = 0;			//bad
				}
			}
		}
	}

	//sampleRate
	if (tableau[20] == '0') {
		if (tableau[21] == '0') {
			if (version == 1) {
				sampleRate = 44100;
			} else if (version == 2) {
				sampleRate = 22050;
			} else if (version == 3) {
				sampleRate = 11025;
			}
		} else {
			if (version == 1) {
				sampleRate = 48000;
			} else if (version == 2) {
				sampleRate = 24000;
			} else if (version == 3) {
				sampleRate = 12000;
			}
		}
	} else {
		if (tableau[21] == '0') {
			if (version == 1) {
				sampleRate = 32000;
			} else if (version == 2) {
				sampleRate = 16000;
			} else if (version == 3) {
				sampleRate = 8000;
			}
		} else {
			sampleRate = 0;
		}
	}
	//padding
	if (tableau[22] == '0') {
		padding = 0;
	} else {
		if (layer == 1) {
			padding = 4;
		} else if ((layer == 2) || (layer == 3)) {
			padding = 1;
		}
	}

	//calculs
	if ((layer == 2) || (layer == 3)) {
		frameLengthInBytes = (long)( ((144 *bitRate*1000) / sampleRate) + padding);
		frameSize = 1152;
	} else {
		frameSize = 384;
	}
	*vers = version;
	*lay  = layer;
	*br   = bitRate;
	*fs   = frameSize;
	*sr   = sampleRate;
	return frameLengthInBytes;
}
void cutWav() {
	long size             = 0;
	long byteRate         = 0;
	long formatChunkSize  = 0;
	long sampleRate       = 0;
	long lenthOfdata      = 0;
	short audioFormat     = 0;
	short channels        = 0;
	short nbBytes         = 0;
	short sampleSize      = 0;
	long TO,FROM,SIZE,newSIZE,nbLu = 0;
	char * data;

	printf("Content-type: audio/wav\n\n");

	fp = fopen(file, "rb");
	fscanf(fp, "RIFF");
	fread(&size,sizeof(size),1,fp);
	fscanf(fp, "WAVEfmt ");
	fread(&formatChunkSize,sizeof(formatChunkSize),1,fp);
	fread(&audioFormat,sizeof(audioFormat),1,fp);
	fread(&channels,sizeof(channels),1,fp);
	fread(&sampleRate,sizeof(sampleRate),1,fp);
	fread(&byteRate,sizeof(byteRate),1,fp);
	fread(&nbBytes,sizeof(nbBytes),1,fp);
	fread(&sampleSize,sizeof(sampleSize),1,fp);
	fscanf(fp, "data");
	fread(&lenthOfdata,sizeof(lenthOfdata),1,fp);

	/*printf("(formatChunkSize:%d)\n", formatChunkSize);
	printf("(audioFormat:%d)\n", audioFormat);
	printf("(channels:%d)\n", channels);
	printf("(size:%d)\n", size);
	printf("(sampleRate:%d)\n", sampleRate);
	printf("(byteRate:%d)\n", byteRate);
	printf("(nbBytes:%d)\n", nbBytes);
	printf("(sampleSize:%d)\n", sampleSize);
	printf("(lenthOfdata:%d)\n", lenthOfdata );
	*/

	TO    = byteRate * to;
	TO    -= TO % (channels*nbBytes);
	FROM  = byteRate * from;
	FROM -= FROM % (channels*nbBytes);
	SIZE = TO - FROM;
	newSIZE = SIZE + 44 - 8;

	//write header
	printf("RIFF");
	fwrite(&newSIZE, sizeof(newSIZE), 1, stdout);
	printf("WAVEfmt ");
	fwrite(&formatChunkSize, sizeof(formatChunkSize), 1, stdout);
	fwrite(&audioFormat, sizeof(audioFormat), 1, stdout);
	fwrite(&channels, sizeof(channels), 1, stdout);
	fwrite(&sampleRate, sizeof(sampleRate), 1, stdout);
	fwrite(&byteRate, sizeof(byteRate), 1, stdout);
	fwrite(&nbBytes, sizeof(nbBytes), 1, stdout);
	fwrite(&sampleSize, sizeof(sampleSize), 1, stdout);
	printf("data");
	fwrite(&SIZE, sizeof(SIZE), 1, stdout);

	//write data
	data = (char*) malloc(SIZE);
	fseek(fp, FROM, 1);
	nbLu = fread(data,1,SIZE,fp);
	fwrite(data,1,nbLu,stdout);

	fclose(fp);
}
void cutMp3() {
	long        frameLengthInBytes = 0;
	long        sampleRate = 0;
	int         frameSize = 0;
	int         version = 0;
	int         layer = 0;
	int         bitRate = 0;
	char        c1,c2,c3,c4;
	long        nbLu = -1;
	double      FROM, TO;
	double      compteur = 0;

	printf("Content-type: audio/mpeg;name=audiocut.mp3\n\n");
	fp = fopen(file, "rb");
	nbLu = fscanf(fp, "%c %c %c %c", &c1, &c2, &c3, &c4);
	frameLengthInBytes = readHeader(c1, c2, c3, c4, &sampleRate, &frameSize, &version, &layer, &bitRate);
	/*printf("\nversion:%d layer:%d bitrate:%d sampleRate:%g\n", version, layer, bitRate, sampleRate);
	printf("\nlength:%d sampleRate:%g frameSize:%d\n", frameLengthInBytes, sampleRate, frameSize);
	*/

	FROM = (sampleRate*from)/frameSize ;
	TO = (sampleRate*to)/frameSize;
	while (nbLu != 0) {
		char * buff;
		compteur++;
		fseek(fp, -4, SEEK_CUR);
		buff = (char*) malloc(frameLengthInBytes);
		nbLu = fread(buff, 1, frameLengthInBytes, fp);
		if ((compteur >= FROM) && (compteur <= TO)){
			fwrite (buff, 1, nbLu, stdout);
		}
		if (compteur > TO) {
			nbLu = 0;
		} else {
			nbLu = fscanf(fp, "%c %c %c %c", &c1, &c2, &c3, &c4);
			frameLengthInBytes = readHeader(c1, c2, c3, c4, &sampleRate, &frameSize, &version, &layer, &bitRate);
		}
	}
	fclose(fp);
}


int main() {
	char           inbuffer[4096];
	char           *token;
	char           c0,c1,c2,c3;
	int            len;
	const char     *qs = getenv("QUERY_STRING");

	strcpy(inbuffer, qs);
	token = strtok(inbuffer, "&");
	param(token);
	while (token != NULL) {
		token = strtok(NULL, "&");
		if (token != NULL) {
			param(token);
		}
	}
	//non cgi test
	//strcpy(file, "C:/lacito.archivage.vjf.cnrs.fr/archives/Nepal/Hayu/CREDO.mp3");
	//freopen("out.mp3","wb",stdout);
	len = strlen(file);
	c0 = file[len-4];
	c1 = file[len-3];
	c2 = file[len-2];
	c3 = file[len-1];
	if ( (c0=='.') && (c1=='w') && (c2=='a') && (c3=='v') ) {
		cutWav();
	} else if ( (c0=='.') && (c1=='m') && (c2=='p') && (c3=='3') ) {
		cutMp3();
	} else {
		printf("Content-type: text/html\n\n");
		printf("<html><head></head><body>file extension:%c%c%c%c not expected by the software</body>", c0,c1,c2,c3);
	}
}
